/**
 * Copyright 2008-2012 Bull S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.jmx.api;

import javax.management.MBeanOperationInfo;

/**
 * Implementations of this interface can be added dynamically as operations in a BaseModelMBeanExt.
 * @author missonng
 */
public interface IMBeanOperation {
    /**
     * Get the MBeanOperationInfo describing this operation.
     * @return The MBeanOperationInfo describing this operation.
     */
    MBeanOperationInfo getMBeanOperationInfo();

    /**
     * Invoke the operation for this BaseModelMBeanExt id.
     * @param id The BaseModelMBeanExt id.
     * @param args The arguments of this operation.
     * @return The result of the invocation.
     */
    Object invoke(String id, Object[] args);
}
